moSetGetFields = {};

function moSetGetFields:setFieldsPriceUpdate(self, slot, slotName)
	if moFields ~= nil then		
		moFields.userId = 0;
		moFields.buyFields = 0;
		if moFields.fieldsMax > 0 then		
			local userId = g_currentMission:getServerUserId();          
			local buyFields = 0;
			if userId ~= nil then
				moFields.userId = userId;
			end;		
			for a=1, moFields.fieldsMax do
				if moFields[a] ~= nil then				
					moFields[a].price = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].fieldPrice;
					moFields[a].isBuy = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].ownedByPlayer;
					if moFields[a].isBuy then buyFields = buyFields+1;end;
					moFields[a].hectar = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].fieldArea;
				end;			
			end;
			moFields.buyFields = buyFields;
			moGuiMiniPdaSlots.values[slot].foundObjects = moFields.fieldsMax;
		end;
	end;
end;

function moSetGetFields:setFieldsInfoUpdate(self, extraFieldNum)
	if moFieldData == nil then return;end;
	moGuiMiniPdaSlots.fieldsInfo.isUpdate = true;	
	local getFruit = false;	
	local growthLevelAll = 0;
	local growthLevelAllMax = 0;
	function setGetFieldFruits(startX, startZ, endX, endZ, scanField)
		for z=startZ,endZ-1,5 do			
			for x=startX,endX-1,5 do				
				widthZ=z; heightX=x; widthX=x+1; heightZ=z+1;				
				function getField(wx, wz)
					local fieldNumber = 0;
					function isField(startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ)
						for channel=0,3 do
							if Utils.getDensity(g_currentMission.terrainDetailId, channel, startWorldX, startWorldZ, widthWorldX, widthWorldZ, heightWorldX, heightWorldZ) > 0 then
								return true;
							end;
						end;
						return false;
					end;					
					if isField( x, z, x+1, z+1, x-1, z-1) then
						if moGuiMiniPdaSlots.fieldsInfo.calculation == 1 then
							for fieldNum,fieldDef in ipairs(moFieldDef) do
								for _,tableValues in ipairs(fieldDef) do
									if tableValues.x1 <= wx and wx <= tableValues.x2 and tableValues.z1 <= wz and wz <= tableValues.z2 then								
										local wX, wZ, wWX, wWZ, wHX, wHZ = Utils.getXZWidthAndHeight(g_currentMission.terrainDetailId, wx, wz, tableValues.x1, tableValues.z1, tableValues.x2, tableValues.z2);
										local foundField = getDensityAtWorldPos(g_currentMission.terrainDetailId, wX, wZ);
										if foundField == nil or foundField <= 0 then break;end;
										fieldNumber = fieldNum;
										break;
									end;
								end;
								if fieldNumber ~= 0 then break;end;
							end;
						else
							if moFieldData[scanField].startX <= wx and wx <= moFieldData[scanField].endX and moFieldData[scanField].startZ <= wz and wz <= moFieldData[scanField].endZ then								
								local wX, wZ, wWX, wWZ, wHX, wHZ = Utils.getXZWidthAndHeight(g_currentMission.terrainDetailId, wx, wz, moFieldData[scanField].startX, moFieldData[scanField].startZ, moFieldData[scanField].endX, moFieldData[scanField].endZ);
								local foundField = getDensityAtWorldPos(g_currentMission.terrainDetailId, wX, wZ);
								if foundField ~= nil and foundField > 0 then
									fieldNumber = scanField;
								end;
							end;
						end;
					end;
					return fieldNumber;
				end;
				local fieldNum = getField(x+1, z+1)
				if fieldNum <= 0 or fieldNum ~= scanField then					
					--moFields[scanField].noFieldAreas = moFields[scanField].noFieldAreas+1
				else
					moFields[fieldNum].fieldAreas = moFields[fieldNum].fieldAreas+1				
					moFields[fieldNum].isUpdate = true;
					for index,fruit in pairs(moFruitTypes) do					
						local xxx,zzz, wX,wZ, hX,hZ = Utils.getXZWidthAndHeight(moFruitTypes[index].id, x, z, widthX, widthZ, heightX, heightZ);
						local valy,area,totalArea = getDensityParallelogram(moFruitTypes[index].id, xxx, zzz, wX, wZ, hX, hZ, 0, g_currentMission.numFruitStateChannels);
						if valy ~= 0 then
							local fertilizerState = Utils.getDensity(g_currentMission.terrainDetailId, 4, x, z, widthX, widthZ, heightX, heightZ);							
							if fertilizerState ~= nil and fertilizerState ~= 0 then moFields[fieldNum].fertilizerAreas = moFields[fieldNum].fertilizerAreas+1;end;
							local literPerSqm = moFruitTypes[index].literPerSqm;
							local growthLevel = valy/area;
							local minState = moFruitTypes[index].minHarvestingGrowthState;
							local maxState = moFruitTypes[index].maxHarvestingGrowthState+1;
							local cutState = moFruitTypes[index].cutState+1;
							if moFruitTypes[index].minPreparingGrowthState > 0 then
								minState = moFruitTypes[index].minPreparingGrowthState;
								maxState = moFruitTypes[index].maxPreparingGrowthState+1;
							end;
							getFruit = true;													
							if growthLevel > maxState and growthLevel > cutState then --rotten
								moFields[fieldNum].rottenAreas = moFields[fieldNum].rottenAreas+1;								
							elseif growthLevel > maxState and growthLevel <= cutState then --geerntet
								if moFields[fieldNum].cutFruits[moFruitTypes[index].descName] == nil then moFields[fieldNum].cutFruits[moFruitTypes[index].descName] = {};moFields[fieldNum].cutFruits[moFruitTypes[index].descName].areas = 0;end;
								moFields[fieldNum].cutAreas = moFields[fieldNum].cutAreas+1;								
								moFields[fieldNum].cutFruits[moFruitTypes[index].descName].areas = moFields[fieldNum].cutFruits[moFruitTypes[index].descName].areas+1;
								moFields[fieldNum].cutFruits[moFruitTypes[index].descName].fruitName = moFruitTypes[index].fruitName;								
							elseif growthLevel <= maxState and growthLevel > minState then --ernten
								if moFields[fieldNum].harvestFruits[moFruitTypes[index].descName] == nil then moFields[fieldNum].harvestFruits[moFruitTypes[index].descName] = {};moFields[fieldNum].harvestFruits[moFruitTypes[index].descName].areas = 0;moFields[fieldNum].harvestFruits[moFruitTypes[index].descName].lqm = 0;end;
								moFields[fieldNum].harvestAreas = moFields[fieldNum].harvestAreas+1;
								moFields[fieldNum].harvestFruits[moFruitTypes[index].descName].lqm = literPerSqm;
								moFields[fieldNum].harvestFruits[moFruitTypes[index].descName].areas = moFields[fieldNum].harvestFruits[moFruitTypes[index].descName].areas+1;
								moFields[fieldNum].harvestFruits[moFruitTypes[index].descName].fruitName = moFruitTypes[index].fruitName;															
							elseif growthLevel <= minState then--wachstum								
								growthLevelAll = growthLevelAll+growthLevel;
								growthLevelAllMax = growthLevelAllMax+(minState+1);
								if moFields[fieldNum].growthFruits[moFruitTypes[index].descName] == nil then moFields[fieldNum].growthFruits[moFruitTypes[index].descName] = {};moFields[fieldNum].growthFruits[moFruitTypes[index].descName].areas = 0;end;
								moFields[fieldNum].growthAreas = moFields[fieldNum].growthAreas+1;
								moFields[fieldNum].growthFruits[moFruitTypes[index].descName].areas = moFields[fieldNum].growthFruits[moFruitTypes[index].descName].areas+1;
								moFields[fieldNum].growthFruits[moFruitTypes[index].descName].fruitName = moFruitTypes[index].fruitName;								
							else
								moFields[fieldNum].unknownAreas = moFields[fieldNum].unknownAreas+1;
							end;							
						end;
						if moFruitTypes[index].windrowId > 0 then
							valy,area,totalArea = getDensityParallelogram(moFruitTypes[index].windrowId, xxx, zzz, wX, wZ, hX, hZ, 0, g_currentMission.numWindrowChannels);
							if valy ~= 0 then
								local literPerSqm = moFruitTypes[index].windrowLiterPerSqm;
								if moFields[fieldNum].windrowFruits[moFruitTypes[index].descName] == nil then moFields[fieldNum].windrowFruits[moFruitTypes[index].descName] = {};moFields[fieldNum].windrowFruits[moFruitTypes[index].descName].areas = 0;moFields[fieldNum].windrowFruits[moFruitTypes[index].descName].lqm = 0;end;
								moFields[fieldNum].windrowAreas = moFields[fieldNum].windrowAreas+1;
								moFields[fieldNum].windrowFruits[moFruitTypes[index].descName].lqm = literPerSqm;
								moFields[fieldNum].windrowFruits[moFruitTypes[index].descName].areas = moFields[fieldNum].windrowFruits[moFruitTypes[index].descName].areas+1;
								moFields[fieldNum].windrowFruits[moFruitTypes[index].descName].fruitName = moFruitTypes[index].windrowName;
							end;
						end;
						local ploughState = Utils.getDensity(g_currentMission.terrainDetailId, 1, x, z, widthX, widthZ, heightX, heightZ);
						if ploughState ~= nil and ploughState ~= 0 then moFields[fieldNum].ploughAreas = moFields[fieldNum].ploughAreas+1;break;end;
						if getFruit then moFields[fieldNum].fruitAreas = moFields[fieldNum].fruitAreas+1;break;end;
					--end;				
					end;
					if not getFruit then moFields[fieldNum].noFruitAreas = moFields[fieldNum].noFruitAreas+1;end;
				end;
				if getFruit then
					getFruit = false;								
				end;
			end;
		end;		
	end;	
	function setProzent(fieldNum)
		local fieldAreas = moFields[fieldNum].fieldAreas;
		local ratio = Utils.getNoNil(moFields[fieldNum].fruitAreas/fieldAreas*100, 0);
		local prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));		
		moFields[fieldNum].usageAreas = prozent;				
		if moFields[fieldNum].harvestAreas ~= 0 then
			ratio = Utils.getNoNil(moFields[fieldNum].harvestAreas/fieldAreas*100, 0);			
			prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
			if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax then
				moFields[fieldNum].harvestAreas = prozent;				
				for k,v in pairs(moFields[fieldNum].harvestFruits) do
					ratio = Utils.getNoNil(v.areas/fieldAreas*100, 0);
					prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
					local setGrass = true;
					if k == "grass" then
						if tonumber(prozent) < moGuiMiniPdaSlots.fieldsInfo.ignoreGrass or not moGuiMiniPdaSlots.fieldsInfo.seeGrass then setGrass = false;end;
					end;
					if tonumber(prozent) > tonumber(moGuiMiniPdaSlots.fieldsInfo.ignoreMax) and setGrass then						
						v.areas = prozent;
						v.fillLevel = string.format("%1.0f", Utils.getNoNil(moFields[fieldNum].sqm*ratio*v.lqm, 0));
						--print(tostring(v1.fruitName).. " - ".. tostring(auslastung).. "% (~".. tostring(fillLevel).. "L x2)");
						moFields[fieldNum].harvestFruitsLength = moFields[fieldNum].harvestFruitsLength+1;
					else						
						moFields[fieldNum].harvestFruits[k] = nil;						
					end;
				end;
			else
				moFields[fieldNum].harvestAreas = 0;
			end;			
		end;
		if moFields[fieldNum].growthAreas ~= 0 then		
			ratio = Utils.getNoNil(moFields[fieldNum].growthAreas/fieldAreas*100, 0);
			prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
			if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax then
				local levelMax = Utils.getNoNil(growthLevelAll/moFields[fieldNum].growthAreas, 0);
				local maxProzent = Utils.getNoNil(growthLevelAllMax/moFields[fieldNum].growthAreas, 0);
				moFields[fieldNum].growthLevel = string.format("%0.1f", Utils.getNoNil(levelMax, 0));
				moFields[fieldNum].growthProzent = string.format("%0.2f", Utils.getNoNil(levelMax/maxProzent*100, 0));				
				moFields[fieldNum].growthAreas = prozent;
				for k,v in pairs(moFields[fieldNum].growthFruits) do				
					ratio = Utils.getNoNil(v.areas/fieldAreas*100, 0);
					prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
					local setGrass = true;
					if k == "grass" then
						if tonumber(prozent) < moGuiMiniPdaSlots.fieldsInfo.ignoreGrass or not moGuiMiniPdaSlots.fieldsInfo.seeGrass then setGrass = false;end;
					end;
					if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax and setGrass then
						v.areas = prozent;
						moFields[fieldNum].growthFruitsLength = moFields[fieldNum].growthFruitsLength+1;
					else
						moFields[fieldNum].growthFruits[k] = nil;
					end;
				end;
			else
				moFields[fieldNum].growthAreas = 0;
			end;
		end;		
		if moFields[fieldNum].fertilizerAreas ~= 0 then
			ratio = Utils.getNoNil(moFields[fieldNum].fertilizerAreas/fieldAreas*100, 0);
			prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
			if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax then
				moFields[fieldNum].fertilizerAreas = prozent;
			else
				moFields[fieldNum].fertilizerAreas = 0;
			end;
		end;
		if moFields[fieldNum].cutAreas ~= 0 then
			ratio = Utils.getNoNil(moFields[fieldNum].cutAreas/fieldAreas*100, 0);
			prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
			if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax then
				moFields[fieldNum].cutAreas = prozent;
				for k,v in pairs(moFields[fieldNum].cutFruits) do				
					ratio = Utils.getNoNil(v.areas/fieldAreas*100, 0);
					prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
					local setGrass = true;
					if k == "grass" then
						if tonumber(prozent) < moGuiMiniPdaSlots.fieldsInfo.ignoreGrass or not moGuiMiniPdaSlots.fieldsInfo.seeGrass then setGrass = false;end;
					end;
					if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax and setGrass then
						v.areas = prozent;
						moFields[fieldNum].cutFruitsLength = moFields[fieldNum].cutFruitsLength+1;
					else
						moFields[fieldNum].cutFruits[k] = nil;
					end;
				end;
			else
				moFields[fieldNum].cutAreas = 0;
			end;
		end;
		if moFields[fieldNum].rottenAreas ~= 0 then
			ratio = Utils.getNoNil(moFields[fieldNum].rottenAreas/fieldAreas*100, 0);
			prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
			if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax then
				moFields[fieldNum].rottenAreas = prozent;
				for k,v in pairs(moFields[fieldNum].rottenFruits) do				
					ratio = Utils.getNoNil(v.areas/fieldAreas*100, 0);
					prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
					local setGrass = true;
					if k == "grass" then
						if tonumber(prozent) < moGuiMiniPdaSlots.fieldsInfo.ignoreGrass or not moGuiMiniPdaSlots.fieldsInfo.seeGrass then setGrass = false;end;
					end;
					if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax and setGrass then
						v.areas = prozent;
						moFields[fieldNum].rottenFruitsLength = moFields[fieldNum].rottenFruitsLength+1;
					else
						moFields[fieldNum].rottenFruits[k] = nil;
					end;
				end;
			else
				moFields[fieldNum].rottenAreas = 0;
			end;
		end;		
		if moFields[fieldNum].ploughAreas ~= 0 then
			ratio = Utils.getNoNil(moFields[fieldNum].ploughAreas/fieldAreas*100, 0);
			prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
			if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax then
				moFields[fieldNum].ploughAreas = prozent;
			else
				moFields[fieldNum].ploughAreas = 0;
			end;
		end;
		if moFields[fieldNum].windrowAreas ~= 0 then
			ratio = Utils.getNoNil(moFields[fieldNum].windrowAreas/fieldAreas*100, 0);
			prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
			if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax then
				moFields[fieldNum].windrowAreas = prozent;
				for k,v in pairs(moFields[fieldNum].windrowFruits) do				
					ratio = Utils.getNoNil(v.areas/fieldAreas*100, 0);
					prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
					if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax then
						v.areas = prozent;
						v.fillLevel = string.format("%1.0f", Utils.getNoNil(moFields[fieldNum].sqm*ratio*v.lqm, 0));
						moFields[fieldNum].windrowFruitsLength = moFields[fieldNum].windrowFruitsLength+1;
					else
						moFields[fieldNum].windrowFruits[k] = nil;
					end;
				end;
			else
				moFields[fieldNum].windrowAreas = 0;
			end;
		end;	
		if moFields[fieldNum].unknownAreas ~= 0 then
			ratio = Utils.getNoNil(moFields[fieldNum].unknownAreas/fieldAreas*100, 0);
			prozent = string.format("%0.2f", Utils.getNoNil(ratio, 0));
			if tonumber(prozent) > moGuiMiniPdaSlots.fieldsInfo.ignoreMax then
				moFields[fieldNum].unknownAreas = prozent;
			else
				moFields[fieldNum].unknownAreas = 0;
			end;
		end;
		getFruit = false;	
		growthLevelAll = 0;
		growthLevelAllMax = 0;
	end;
	function setCalculation(fieldNum)
		moFields[fieldNum].cornerPoints = false;
		moFields[fieldNum].harvestAreas = 0;
		moFields[fieldNum].harvestFruits = {};
		moFields[fieldNum].harvestFruitsLength = 0;
		moFields[fieldNum].cutAreas = 0;
		moFields[fieldNum].cutFruits = {};
		moFields[fieldNum].cutFruitsLength = 0;
		moFields[fieldNum].rottenAreas = 0;
		moFields[fieldNum].rottenFruits = {};
		moFields[fieldNum].rottenFruitsLength = 0;
		moFields[fieldNum].growthAreas = 0;
		moFields[fieldNum].growthLevel = 0;
		moFields[fieldNum].growthProzent = 0;
		moFields[fieldNum].growthFruits = {};
		moFields[fieldNum].growthFruitsLength = 0;
		moFields[fieldNum].unknownAreas = 0;
		moFields[fieldNum].windrowAreas = 0;
		moFields[fieldNum].windrowFruits = {};
		moFields[fieldNum].windrowFruitsLength = 0;
		moFields[fieldNum].fertilizerAreas = 0;
		moFields[fieldNum].ploughAreas = 0;
		moFields[fieldNum].fieldAreas = 0;
		moFields[fieldNum].noFieldAreas = 0;
		moFields[fieldNum].noFruitAreas = 0;
		moFields[fieldNum].fruitAreas = 0;
		moFields[fieldNum].usageAreas = 0;
		moFields[fieldNum].bale = 0;
		if moGuiMiniPdaSlots.fieldsInfo.calculation == 1 then
			local firstCornerPoints = false;
			for key,coord in ipairs(moFieldDef[fieldNum]) do
				if coord == nil then break;end;
				setGetFieldFruits(coord.x1, coord.z1, coord.x2, coord.z2, fieldNum);
				if not firstCornerPoints and coord.cornerPoints then moFields[fieldNum].cornerPoints = true;firstCornerPoints = true;end;
			end;			
		else
			if moFieldData[fieldNum] ~= nil then
				setGetFieldFruits(moFieldData[fieldNum].startX, moFieldData[fieldNum].startZ, moFieldData[fieldNum].endX, moFieldData[fieldNum].endZ, fieldNum);
				moFields[fieldNum].cornerPoints = moFieldData[fieldNum].cornerPoints
			end;
		end;
		setProzent(fieldNum);
	end;
	function isFieldUpdateScan(fieldNum)
		local isBuy = moFields[fieldNum].isBuy;
		if moGuiMiniPdaSlots.fieldsInfo.updateSwitch == 0 then return true;
		elseif moGuiMiniPdaSlots.fieldsInfo.updateSwitch == 1 and isBuy then return true;
		elseif moGuiMiniPdaSlots.fieldsInfo.updateSwitch == 2 and not isBuy then return true;end;
		return false;
	end;
	if moFields ~= nil and moFields.fieldsMax > 0 then
		if extraFieldNum == nil then
			for a=1, moFields.fieldsMax do
				if moFields[a] ~= nil and isFieldUpdateScan(a) then
					moGuiMiniPdaSlots.fieldsInfo.fieldUpdateNum = a;
					setCalculation(a);
				end;
			end;
			--if string.len(moGuiMiniPdaSlots.fieldsInfo.scanFields) <= 0 then
			--	for a=1, moFields.fieldsMax do
			--		if moFields[a] ~= nil then
			--			moGuiMiniPdaSlots.fieldsInfo.fieldUpdateNum = a;
			--			setCalculation(a);
			--		end;
			--	end;
			--else
			--	local splitScanFields = Utils.splitString(",", moGuiMiniPdaSlots.fieldsInfo.scanFields);
			--	for a=1, table.getn(splitScanFields) do
			--		if splitScanFields[a] ~= nil and string.len(splitScanFields[a]) > 0 then
			--			local fieldNum = tonumber(splitScanFields[a]);
			--			if moFields[fieldNum] ~= nil then
			--				moGuiMiniPdaSlots.fieldsInfo.fieldUpdateNum = fieldNum;
			--				setCalculation(fieldNum);
			--			end;
			--		end;
			--	end;
			--end;
		else
			moGuiMiniPdaSlots.fieldsInfo.fieldUpdateNum = extraFieldNum;
			setCalculation(extraFieldNum);
		end;
	end;
	moGuiMiniPdaSlots.fieldsInfo.isUpdate = false;
	moGuiMiniPdaSlots.fieldsInfo.fieldUpdateNum = 0;
	moGuiMiniPdaSlots.fieldsInfo.scanFields = "";	
end;

function moSetGetFields:setFieldsDefination(self, fieldNum)
	moFieldDef = {};
	moFieldDefNew = {};
	moFieldDefNew[1] = {};
	moFieldData = {};
	function getFieldValues(fieldDef)
		local fieldValues = {};
		if fieldDef ~= nil and fieldDef.fieldDimensions ~= nil then			
			local mapIndicatorX = 0;
			local mapIndicatorZ = 0;
			if fieldDef.fieldMapIndicator ~= nil then
				local wx, _, wz = getWorldTranslation(fieldDef.fieldMapIndicator);
				if wx ~= nil and wz ~= nil then
					mapIndicatorX = wx;
					mapIndicatorZ = wz;
				end;
			end;
			local cornerPoints = false;
			for a=0, getNumOfChildren(fieldDef.fieldDimensions) - 1 do
				local b1 = getChildAt(fieldDef.fieldDimensions, a);
				local b2 = getChildAt(b1, 0);
				local b3 = getChildAt(b1, 1);
				local c1 = { getWorldTranslation(b1) };
				local c2 = { getWorldTranslation(b2) };
				local c3 = { getWorldTranslation(b3) };
				--local overlap = 2; --VI !!
				local x1 = math.min(c1[1],c2[1],c3[1]) --- overlap;
				local z1 = math.min(c1[3],c2[3],c3[3]) --- overlap;
				local x2 = math.max(c1[1],c2[1],c3[1]) --+ overlap;
				local z2 = math.max(c1[3],c2[3],c3[3]) --+ overlap;								
				if not cornerPoints and mapIndicatorX >= x1 and mapIndicatorX <= x2 and mapIndicatorZ >= z1 and mapIndicatorZ <= z2 then						
					cornerPoints = true;
				end;				
				table.insert(fieldValues, {x1=x1,z1=z1,x2=x2,z2=z2,mapIndicatorX=mapIndicatorX,mapIndicatorZ=mapIndicatorZ,cornerPoints=cornerPoints});				
			end;			
		end;
		return fieldValues;
    end;
	function setFieldMapValues(fieldDef, fieldNum)
		--map scan total
		if fieldDef ~= nil and fieldDef.fieldDimensions ~= nil then				
			moFieldData[fieldNum] = {};
			moFieldData[fieldNum].startX = 99999;
			moFieldData[fieldNum].startZ = 99999;
			moFieldData[fieldNum].endX = 0;
			moFieldData[fieldNum].endZ = 0;
			moFieldData[fieldNum].mapIndicatorX = 0;
			moFieldData[fieldNum].mapIndicatorZ = 0;
			moFieldData[fieldNum].cornerPoints = false;
			if fieldDef.fieldMapIndicator ~= nil then
				local wx, _, wz = getWorldTranslation(fieldDef.fieldMapIndicator);
				if wx ~= nil and wz ~= nil then
					moFieldData[fieldNum].mapIndicatorX = wx;
					moFieldData[fieldNum].mapIndicatorZ = wz;
				end;
			end;
			local x, z, x1, z1, x2, z2, x3, z3 = 0, 0, 0, 0, 0, 0, 0, 0;			 
			local numchild=getNumOfChildren(fieldDef.fieldDimensions);
			if numchild ~= nil and numchild > 0 then
				for i=1,numchild do
					child1=getChildAt(fieldDef.fieldDimensions, i-1)												
					local wx, wy, wz = getWorldTranslation(child1);
					if wx ~= nil and wz ~= nil then								
						x1 = wx; z1 = wz;								
					else
						break;
					end;
					local numgrandchild=getNumOfChildren(child1);
					if numgrandchild ~= nil and numgrandchild > 0 then
						for j=1,numgrandchild do
							child2=getChildAt(child1, j-1);																
							local wx, wy, wz = getWorldTranslation(child2);
							if wx ~= nil and wz ~= nil then								
								x = wx; z = wz;								
								if j == 1 then
									x2 = x; z2 = z;
								else
									x3 = x; z3 = z;
								end;
							else
								break;
							end;
						end;
						moFieldData[fieldNum].startX = math.min(x1, x2, x3, moFieldData[fieldNum].startX);
						moFieldData[fieldNum].startZ = math.min(z1, z2, z3, moFieldData[fieldNum].startZ);
						moFieldData[fieldNum].endX = math.max(x1, x2, x3, moFieldData[fieldNum].endX);
						moFieldData[fieldNum].endZ = math.max(z1, z2, z3, moFieldData[fieldNum].endZ);						
						if moFieldData[fieldNum].startX == 0 then moFieldData[fieldNum].startX = moFieldDef[fieldNum][1].x1;end;							
						if moFieldData[fieldNum].startZ == 0 then moFieldData[fieldNum].startZ= moFieldDef[fieldNum][1].z1;end;
						if moFieldData[fieldNum].endX == 0 then moFieldData[fieldNum].endX = moFieldDef[fieldNum][1].x2;end;
						if moFieldData[fieldNum].endZ == 0 then moFieldData[fieldNum].endZ = moFieldDef[fieldNum][1].z2;end;
						if not moFieldData[fieldNum].cornerPoints and moFieldData[fieldNum].mapIndicatorX >= moFieldData[fieldNum].startX and moFieldData[fieldNum].mapIndicatorX <= moFieldData[fieldNum].endX and moFieldData[fieldNum].mapIndicatorZ >= moFieldData[fieldNum].startZ and moFieldData[fieldNum].mapIndicatorZ <= moFieldData[fieldNum].endZ then						
							moFieldData[fieldNum].cornerPoints = true;
						end;
					end;
				end;
			end;			
		end;				
	end;	
	if g_currentMission.fieldDefinitionBase ~= nil and g_currentMission.fieldDefinitionBase.fieldDefs ~= nil then
		if fieldNum ~= nil and g_currentMission.fieldDefinitionBase.fieldDefs[fieldNum] ~= nil then			
			moFieldDef[fieldNum] = {};
			moFieldDef[fieldNum] = getFieldValues(g_currentMission.fieldDefinitionBase.fieldDefs[fieldNum]);
			if g_currentMission.fieldDefinitionBase.fieldDefs[fieldNum].fieldMapIndicator ~= nil then
				local wx, _, wz = getWorldTranslation(g_currentMission.fieldDefinitionBase.fieldDefs[fieldNum].fieldMapIndicator);
				if wx ~= nil and wz ~= nil then
					moFieldDef[fieldNum].mapIndicatorX = wx;
					moFieldDef[fieldNum].mapIndicatorZ = wz;
				end;
			end;
			setFieldMapValues(g_currentMission.fieldDefinitionBase.fieldDefs[fieldNum], fieldNum);
		else
			for fieldNumber,fieldDef in ipairs(g_currentMission.fieldDefinitionBase.fieldDefs) do				
				moFieldDef[fieldNumber] = {};				
				if fieldDef.fieldMapIndicator ~= nil then
					local wx, _, wz = getWorldTranslation(fieldDef.fieldMapIndicator);
					if wx ~= nil and wz ~= nil then
						moFieldDef[fieldNumber].mapIndicatorX = wx;
						moFieldDef[fieldNumber].mapIndicatorZ = wz;
					end;
				end;
				moFieldDef[fieldNumber] = getFieldValues(fieldDef);
				setFieldMapValues(fieldDef, fieldNumber)				
			end;
		end;
		moGuiMiniPdaSlots.fieldsInfo.lastRefreshFieldsAreas = tostring(moGuiExtras:getMilliSecondsToHours(g_currentMission.environment.dayTime, true));
    end;
	--print(tostring(MultiOverlayV2:tableToString(moFieldData[8])));
	--print("---------------------------");
	--print(tostring(MultiOverlayV2:tableToString(moFieldDef[8])));
end;

function moSetGetFields:setFieldsAndFruitsValues(self)
	moFields = {};	
	moFields.userId = 0;
	moFields.buyFields = 0;
	moFields.fieldsMax = table.getn(g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber);
	if moFields.fieldsMax > 0 then		
		local userId = g_currentMission:getServerUserId();          
		if userId ~= nil then
			moFields.userId = userId;
		end;		
		local buyFields = 0;
		for a=1, moFields.fieldsMax do
			moFields[a] = {};
			moFields[a].fieldNumber = a;
			moFields[a].fieldObject = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a];
			local x,y,z = getWorldTranslation(g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].fieldBuyTrigger);			
			moFields[a].x = x;
			moFields[a].z = z;
			moFields[a].price = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].fieldPrice;
			moFields[a].isBuy = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].ownedByPlayer;
			if moFields[a].isBuy then buyFields = buyFields+1;end;
			moFields[a].hectar = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].fieldArea;
			moFields[a].sqm = g_currentMission.fieldDefinitionBase.fieldDefsByFieldNumber[a].fieldArea*10000/100;
			moFields[a].isUpdate = false;
			moFields[a].cornerPoints = false;
			moFields[a].harvestAreas = 0;
			moFields[a].harvestFruits = {};
			moFields[a].harvestFruitsLength = 0;
			moFields[a].cutAreas = 0;
			moFields[a].cutFruits = {};
			moFields[a].cutFruitsLength = 0;
			moFields[a].rottenAreas = 0;
			moFields[a].rottenFruits = {};
			moFields[a].rottenFruitsLength = 0;
			moFields[a].growthAreas = 0;
			moFields[a].growthLevel = 0;
			moFields[a].growthProzent = 0;
			moFields[a].growthFruits = {};
			moFields[a].growthFruitsLength = 0;
			moFields[a].unknownAreas = 0;
			moFields[a].windrowAreas = 0;
			moFields[a].windrowFruits = {};
			moFields[a].windrowFruitsLength = 0;
			moFields[a].fertilizerAreas = 0;
			moFields[a].ploughAreas = 0;
			moFields[a].fieldAreas = 0;
			moFields[a].noFieldAreas = 0;
			moFields[a].noFruitAreas = 0;
			moFields[a].fruitAreas = 0;
			moFields[a].usageAreas = 0;
			moFields[a].bale = 0;
		end;
		moFields.buyFields = buyFields;		
		local slot = MultiOverlayV2:getSlot("fieldsprice");
		if slot ~= nil and slot ~= 0 then moGuiMiniPdaSlots.values[slot].foundObjects = moFields.fieldsMax;end;
		local slot = MultiOverlayV2:getSlot("fieldsinfo");
		if slot ~= nil and slot ~= 0 then moGuiMiniPdaSlots.values[slot].foundObjects = moFields.fieldsMax;end;
	end;	
end;